
/*********************************************************************

Copyright (C) 1994, 1995 Lawrence Berkeley Laboratory.  All Rights
Reserved.  Permission to copy and modify this software and its
documentation (if any) is hereby granted, provided that this notice
is retained thereon and on all copies.  

This software is provided as a professional academic contribution
for joint exchange.   Thus it is experimental and scientific
in nature, undergoing development, and is provided "as is" with
no warranties of any kind whatsoever, no support, promise of
updates or printed documentation.

This work is supported by the U. S. Department of Energy under 
contract number DE-AC03-76SF00098 between the U. S. Department 
of Energy and the University of California.


	Author: Wes Bethel
		Lawrence Berkeley Laboratory

  "this software is 100% hand-crafted by a human being in the USA"

  this file contains routines which implement a relatively simple
  API to the lower-level spaceball i/o routines contained in sbcustom.c.

*********************************************************************/


#include <stdio.h>

#define Sb_ENVIRONMENT_INCLUDES
#include "sblibry.h"

int mytranslate();
int myrotate();
int mypressed();
int new_data=0;
int tran_on=1;
int rot_on=1;
float transvec[3],rotvec[3];

char sbdev[] = {"/dev/spaceball"};

    char b[200];
    SbUint16 now;

open_spaceball(buttonp,rotatep,transp)
int (*buttonp)(),(*rotatep)(),(*transp)();
{
    /**
      * supply your routines to be called ("callbacks") whenever
      * a) any of the buttons on the spaceball is pushed; b) whenever
      * any rotation event is detected; or c) whenever any translation
      * events are detected.
    **/
    initialize_spaceball(sbdev,buttonp,rotatep,transp);
    SbRequestBallData();
}

int
open_named_spaceball(buttonp,rotatep,transp,spaceball_tty)
int (*buttonp)(),(*rotatep)(),(*transp)();
char *spaceball_tty;
{
    /**
      * similar to open_spaceball(), but the user also supplies the
      * device name, ie, /dev/cua/a on solaris boxes.
    **/
    
    initialize_spaceball(spaceball_tty,buttonp,rotatep,transp);
    SbRequestBallData();
    return(1);  /* meaningless */
}


initialize_spaceball( tty_line ,bp,rp,tp)
char *tty_line;
int (*bp)(),(*rp)(),(*tp)();
{
    if (SbOpen( tty_line ) < 0) {
        printf( "Could not open Spaceball on %s\n", tty_line );
        exit( 1 );
    }
    if (SbReset( TRUE ) == -1)
        printf(
            "Spaceball did not appear to respond on %s - continuing anyway\n",
            tty_line
        );
    SbSetBallMode( "SSV" );     /* turn translations and rotations on */
    SbFunctions.pressed = bp;
    SbFunctions.translate = tp;
    SbFunctions.rotate = rp;
}

